1
0
Fork 0
mirror of https://code.forgejo.org/actions/setup-python.git synced 2024-07-17 20:57:18 +02:00
Go to file
gowridurgad 39cd14951b
Some checks failed
CodeQL analysis / CodeQL analysis (push) Failing after 0s
Licensed / Licensed (push) Failing after 0s
Documentation update for cache (#873)
* updated doc

* added note

* modify1

* Update advanced-usage.md

* Update 0000-caching-dependencies.md

---------

Co-authored-by: gowridurgad <gowridurga@github.com>
2024-07-10 08:48:13 -05:00
.github fix(ci): update all failing workflows (#863) 2024-06-27 13:18:32 -05:00
.licenses/npm Bump braces from 3.0.2 to 3.0.3 (#893) 2024-06-26 12:13:45 -05:00
__tests__ feat: fallback to raw endpoint for manifest when rate limit is reached (#766) 2024-03-26 08:56:00 -05:00
dist Bump braces from 3.0.2 to 3.0.3 (#893) 2024-06-26 12:13:45 -05:00
docs Documentation update for cache (#873) 2024-07-10 08:48:13 -05:00
src feat: fallback to raw endpoint for manifest when rate limit is reached (#766) 2024-03-26 08:56:00 -05:00
.eslintignore Add and configure ESLint and update configuration for Prettier (#617) 2023-03-09 12:44:56 +02:00
.eslintrc.js Update configuration files 2023-05-23 08:23:56 +00:00
.gitattributes Add Licensed To Help Verify Prod Licenses (#128) 2020-09-23 23:22:43 +02:00
.gitignore Cleanup 2019-11-05 17:38:12 -05:00
.licensed.yml Implementation of python's caching (#266) 2021-11-17 13:31:22 +03:00
.prettierignore Add and configure ESLint and update configuration for Prettier (#617) 2023-03-09 12:44:56 +02:00
.prettierrc.js Update configuration files (#622) 2023-03-15 00:32:39 +01:00
action.yml Update action to node20 (#772) 2023-12-05 14:52:09 +01:00
CODE_OF_CONDUCT.md Add CODE_OF_CONDUCT 2022-04-18 16:04:39 +05:00
jest.config.js Consume toolkit from npmjs (#12) 2019-08-20 10:27:52 -04:00
LICENSE Consume toolkit from npmjs (#12) 2019-08-20 10:27:52 -04:00
package-lock.json Bump braces from 3.0.2 to 3.0.3 (#893) 2024-06-26 12:13:45 -05:00
package.json Bump undici from 5.27.2 to 5.28.3 (#817) 2024-03-11 10:03:54 -05:00
README.md Fix broken README.md link (#793) 2024-01-18 11:33:07 +05:30
tsconfig.json Add and configure ESLint and update configuration for Prettier (#617) 2023-03-09 12:44:56 +02:00

setup-python

Basic validation Validate Python e2e Validate PyPy e2e e2e-cache

This action provides the following functionality for GitHub Actions users:

  • Installing a version of Python or PyPy and (by default) adding it to the PATH
  • Optionally caching dependencies for pip, pipenv and poetry
  • Registering problem matchers for error output

Basic usage

See action.yml

Python

steps:
- uses: actions/checkout@v4
- uses: actions/setup-python@v5
  with:
    python-version: '3.10' 
- run: python my_script.py

PyPy

steps:
- uses: actions/checkout@v4
- uses: actions/setup-python@v5 
  with:
    python-version: 'pypy3.9' 
- run: python my_script.py

GraalPy

steps:
- uses: actions/checkout@v4
- uses: actions/setup-python@v5 
  with:
    python-version: 'graalpy-22.3' 
- run: python my_script.py

The python-version input is optional. If not supplied, the action will try to resolve the version from the default .python-version file. If the .python-version file doesn't exist Python or PyPy version from the PATH will be used. The default version of Python or PyPy in PATH varies between runners and can be changed unexpectedly so we recommend always setting Python version explicitly using the python-version or python-version-file inputs.

The action will first check the local tool cache for a semver match. If unable to find a specific version in the tool cache, the action will attempt to download a version of Python from GitHub Releases and for PyPy from the official PyPy's dist.

For information regarding locally cached versions of Python or PyPy on GitHub hosted runners, check out GitHub Actions Runner Images.

Supported version syntax

The python-version input supports the Semantic Versioning Specification and some special version notations (e.g. semver ranges, x.y-dev syntax, etc.), for detailed examples please refer to the section: Using python-version input of the Advanced usage guide.

Supported architectures

Using architecture input it is possible to specify the required Python or PyPy interpreter architecture: x86 or x64. If the input is not specified the architecture defaults to x64.

Caching packages dependencies

The action has built-in functionality for caching and restoring dependencies. It uses toolkit/cache under the hood for caching dependencies but requires less configuration settings. Supported package managers are pip, pipenv and poetry. The cache input is optional, and caching is turned off by default.

The action defaults to searching for a dependency file (requirements.txt or pyproject.toml for pip, Pipfile.lock for pipenv or poetry.lock for poetry) in the repository, and uses its hash as a part of the cache key. Input cache-dependency-path is used for cases when multiple dependency files are used, they are located in different subdirectories or different files for the hash that want to be used.

  • For pip, the action will cache the global cache directory
  • For pipenv, the action will cache virtualenv directory
  • For poetry, the action will cache virtualenv directories -- one for each poetry project found

Caching pip dependencies:

steps:
- uses: actions/checkout@v4
- uses: actions/setup-python@v5
  with:
    python-version: '3.9'
    cache: 'pip' # caching pip dependencies
- run: pip install -r requirements.txt

Note: Restored cache will not be used if the requirements.txt file is not updated for a long time and a newer version of the dependency is available which can lead to an increase in total build time.

The requirements file format allows for specifying dependency versions using logical operators (for example chardet>=3.0.4) or specifying dependencies without any versions. In this case the pip install -r requirements.txt command will always try to install the latest available package version. To be sure that the cache will be used, please stick to a specific dependency version and update it manually if necessary.

See examples of using cache and cache-dependency-path for pipenv and poetry in the section: Caching packages of the Advanced usage guide.

Advanced usage

License

The scripts and documentation in this project are released under the MIT License.

Contributions

Contributions are welcome! See our Contributor's Guide.